/*

------------Drumersl's Directional Movement Library------------

		This library can be used to create walls that are less
	than one tile thick, like the walls in Last Robot
	Standing. It is really not hard to use, it only requires
	the addition of one or two variables to define which
	directions to block. The hardest part is figuring out
	what to assign to those variables.

		All you have to do to use this library is include it in
	your program by clicking the checkbox next to its name in
	the Lib folder. Once you do that you can use two new turf vars,
	tbit and ntbit. tbit is used to determine which directions
	you can enter the tile from, and ntbit determines which
	directions you can exit it from. For instance, if you wanted
	to make a wall for the top of the tile, you would want to
	block north for entering and exciting.

	The hardest part of using this is figuring out the binary
	code for the directions. I have included a list of every
	possible combination of directions and the equivalent code
	for the direction. To block the directions listed just set
	tbit and/or ntbit equal to the decimal number, (the one
	that isn't all 1s and 0s. If you want to block the same
	directions for both entering and exciting, you only need
	to set the tbit var for that turf.

----------------------------------------------------------------

**************************************************************************************************
	Here is an example of its use:

	turf
		grass
			icon = 'turf.dmi'
			NE
				icon_state = "ne"
				tbit = 7 //tbit = 7 blocks the NE corner of a tile, NORTH, NORTHEAST, and EAST
			NW
				icon_state = "nw"
				tbit = 193 //tbit = 193 blocks the NW corner of a tile, NORTH, NORTHWEST, and WEST
**************************************************************************************************

	Thank you for your support, if you do plan on using this
	library it would be nice if I recived a bit of credit for
	it. If you have any questions or suggestions feel free to
	contact me on the pager, drumersl, AIM, drumers, or e-mail,
	drumersl@gmail.com. Also if you have a TI-83+ calculator, I
	have written a program for it to determine the value needed
	so you don't have to use the chart. If you would like the
	program just e-mail me. Thanks again.

	This library was made with the help of sapphiremagus and Lummox JR

*/

//You really don't need to care about this file, unless of course you want to be a better programmer//


turf
	var
		tbit = 0
		ntbit = 0

var/list/dir_to_bitflag = list(1,16,0,4,2,8,0,64,128,32)

turf
	Enter(var/atom/movable/ent)
		if(!..()) return 0
		var/d = get_dir(src, ent)
		if(d && (dir_to_bitflag[d] & tbit)) return 0
		else return 1

	Exit(var/atom/movable/ent)
		if(!ntbit) ntbit = tbit
		if(!..()) return 0
		var/d = ent.dir
		if(d && (dir_to_bitflag[d] & ntbit)) return 0
		else return 1

